#ifndef __DEFCONF_H
#include "defconf.h"
#endif
/* by tantan */
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

/*************************************************************************\
*
*  ֐: backup_sec()
*
*  : t@C̃ZLeBt@Cɕۑ
*
\*************************************************************************/
void backup_sec(char *name,FILE *fp)
{
    DWORD   required;
    TCHAR   buf[4096];
    BOOL    status;
    int  bufsize=1;

resize:

    if ((status = GetFileSecurity(name,
                  OWNER_SECURITY_INFORMATION | GROUP_SECURITY_INFORMATION
                              | DACL_SECURITY_INFORMATION ,
                  buf,
                  bufsize,
                  &required)) == FALSE) {
        if(required != 0){
/*            fprintf(stderr, "%s: error more sd %d  now %d\n", name, required,bufsize);*/
            bufsize = required;
	    if (bufsize >= 4096){
               fprintf(stderr, "%s: error more sd %d  now 4096\n", name, required);
		exit(1);
	    }
            goto resize;
        }else
            fprintf(stderr, "%s: error %d\n", name, GetLastError());
        return;
    }
    fwrite(&bufsize,4,1,fp);  /* header 4byte integer */
    fwrite(buf,bufsize,1,fp); /* Security Description */
}

/*************************************************************************\
*
*  ֐: restore_sec()
*
*  : t@C̃ZLeBt@C烊XgA
*
\*************************************************************************/
void restore_sec(char *name,FILE *fp)
{
    TCHAR   buf[4096];
    BOOL    status;
    int bufsize;

    fread(&bufsize,4,1,fp);  /* header 4byte integer */
    fread(buf,bufsize,1,fp); /* Security Description */

/*   printf("name %s \n",name);*/

    if ((status = SetFileSecurity(name,
                  OWNER_SECURITY_INFORMATION | GROUP_SECURITY_INFORMATION
                              | DACL_SECURITY_INFORMATION ,
                  buf)) == FALSE) {
            fprintf(stderr, "%s: error %d\n", name, GetLastError());
        return;
    }
}

